(************************************************)
(* File -> buffer LZSS decoder                  *)
(* Original routine by Haruhiko Okumura, 1989   *)
(* Ported to Pascal by Asp / VR group, 1998     *)
(* Unit version : 1.12                          *)
(* Last updated : 02.Jan.2000                   *)
(************************************************)

unit unlz;
{.$DEFINE _DEBUG_}

interface

function lzsDecode(var Data:file; Buffer:pointer; DataLength:longint):longint;

implementation
{$I release.opt}

const N=4096;
      F=18;
      THRESHOLD=2;
      IO_BUF_SIZE=32768;
var text_buf:array[0..N+F-2] of byte;
{$IFDEF _DEBUG_}
    IoBuf:array[0..IO_BUF_SIZE-1] of byte;
{$ENDIF}

function lzsDecode(var Data:file; Buffer:pointer; DataLength:longint):longint;
type TBuffer=array[0..IO_BUF_SIZE-1] of byte;
     PBuffer=^TBuffer;
var flags:word;
    r,TextCounter:longint;
    InBuffer:PBuffer;
    InBufCounter:word;

function getc:integer;
var Dummy:longint;
begin
 if InBufCounter>IO_BUF_SIZE-1 then begin
  BlockRead(Data,InBuffer^,IO_BUF_SIZE,Dummy);
  InBufCounter:=0;
 end;
 inc(TextCounter);
 getc:=integer(InBuffer^[InBufCounter]);
 inc(InBufCounter);
end;

begin
{$IFDEF _DEBUG_}
 InBuffer:=@IoBuf;
{$ELSE}
 GetMem(InBuffer,IO_BUF_SIZE);
{$ENDIF}
 asm
  push Buffer
  mov InBufCounter,IO_BUF_SIZE
  mov TextCounter,0
  mov r,N-F
  mov flags,0
  mov edi,offset text_buf
  mov ecx,(N-F-2)/4
  mov eax,20202020h
  rep stosd
  stosw
@@1:
  shr flags,1
  test flags,256
  jnz @@2
  mov eax,TextCounter
  cmp eax,DataLength
  je @@Done
  call getc
  or ax,0FF00h
  mov flags,ax
@@2:
  test flags,1
  jz @@3
  mov eax,TextCounter
  cmp eax,DataLength
  je @@Done
  call getc
  mov ebx,r
  mov [ebx+offset text_buf],al
  mov edi,Buffer
  mov [edi],al
  inc Buffer
  inc r
  and r,N-1
  jmp @@1
@@3:
  mov eax,TextCounter
  cmp eax,DataLength
  je @@Done
  call getc
  movzx edx,ax
  mov eax,TextCounter
  cmp eax,DataLength
  je @@Done
  call getc
  mov ebx,eax
  and ebx,0F0h
  shl ebx,4
  or edx,ebx
  and eax,0Fh
  add eax,THRESHOLD
  xor ecx,ecx
@@4:
  mov ebx,edx
  add ebx,ecx
  and ebx,N-1
  mov esi,eax
  mov al,[ebx+offset text_buf]
  mov ebx,r
  mov [ebx+offset text_buf],al
  mov edi,Buffer
  mov [edi],al
  mov eax,esi
  inc Buffer
  inc r
  and r,N-1
  inc ecx
  cmp ecx,eax
  jna @@4
  jmp @@1
@@Done:
  pop eax
  sub Buffer,eax
 end;
{$IFNDEF _DEBUG_}
 FreeMem(InBuffer,IO_BUF_SIZE);
{$ENDIF}
 lzsDecode:=longint(Buffer);
end;

end.

